/*
 * @(#)ConfigurationBits.java	0.1 04/08/13 SMI
 *
 * Copyright (c) 2004 Martin Dubuc All Rights Reserved.
 *
 * Martin Dubuc grants you ("Licensee") a non-exclusive, royalty free, license
 * to use, modify and redistribute this software in source and binary
 * code form, provided that i) this copyright notice and license appear
 * on all copies of the software; and ii) Licensee does not utilize the
 * software in a manner which is disparaging to Martin Dubuc.
 *
 * This software is provided "AS IS," without a warranty of any kind.
 * ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES,
 * INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. MARTIN DUBUC AND
 * ITS LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THE
 * SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL MARTIN DUBUC OR ITS LICENSORS
 * BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES,
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING
 * OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF MARTIN DUBUC HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control
 * of aircraft, air traffic, aircraft navigation or aircraft
 * communications; or in the design, construction, operation or
 * maintenance of any nuclear facility. Licensee represents and
 * warrants that it will not use or redistribute the Software for such
 * purposes.
 */

import java.util.StringTokenizer;

public class ConfigurationBits {
	private boolean usbpll;
	private boolean cpudiv;
	private boolean plldiv;
	private boolean ieso;
	private boolean fscm;
	private boolean oscsen;
	private boolean fosc20;
	private boolean fosc30;
	private boolean vregen;
	private boolean borv;
	private boolean boren;
	private boolean boren10;
	private boolean pwrten;
	private boolean winen;
	private boolean wdtps30;
	private boolean wdtps20;
	private boolean wdten;
	private boolean wait;
	private boolean abw;
	private boolean bw;
	private boolean gptren;
	private boolean nott1oscmx;
	private boolean hpol;
	private boolean lpol;
	private boolean pwmpin;
	private boolean pm;
	private boolean mclre;
	private boolean exclkmx;
	private boolean pwm4mx;
	private boolean sspmx;
	private boolean lpt1osc;
	private boolean t1oscmx;
	private boolean pbaden;
	private boolean eccpmx;
	private boolean fltamx;
	private boolean ccp2mx;
	private boolean debug;
	private boolean xinst;
	private boolean bbsiz;
	private boolean icprt;
	private boolean lvp;
	private boolean stvren;
	private boolean cp7;
	private boolean cp6;
	private boolean cp5;
	private boolean cp4;
	private boolean cp3;
	private boolean cp2;
	private boolean cp1;
	private boolean cp0;
	private boolean cp;
	private boolean cpd;
	private boolean cpb;
	private boolean wrt7;
	private boolean wrt6;
	private boolean wrt5;
	private boolean wrt4;
	private boolean wrt3;
	private boolean wrt2;
	private boolean wrt1;
	private boolean wrt0;
	private boolean wrtd;
	private boolean wrtb;
	private boolean wrtc;
	private boolean ebtr7;
	private boolean ebtr6;
	private boolean ebtr5;
	private boolean ebtr4;
	private boolean ebtr3;
	private boolean ebtr2;
	private boolean ebtr1;
	private boolean ebtr0;
	private boolean ebtr;
	private boolean ebtrb;
	
	public ConfigurationBits() {
	} // ConfigurationBits

	public ConfigurationBits(String configBits) {
		super();
		
		StringTokenizer st = new StringTokenizer(configBits, ",");
		String token;
		
		while (st.hasMoreTokens()) {
			token = st.nextToken();
			
			if (token.equals("USBPLL"))
				usbpll = true;
			else if (token.equals("CPUDIV"))
				cpudiv = true;
			else if (token.equals("PLLDIV"))
				plldiv = true;
			else if (token.equals("IESO"))
				ieso = true;
			else if (token.equals("FSCM"))
				fscm = true;
			else if (token.equals("FCMEN"))
				fscm = true;
			else if (token.equals("OSCSEN"))
				oscsen = true;
			else if (token.equals("FOSC20"))
				fosc20 = true;
			else if (token.equals("FOSC30"))
				fosc30 = true;
			else if (token.equals("VREGEN"))
				vregen = true;
			else if (token.equals("BORV"))
				borv = true;
			else if (token.equals("BOREN"))
				boren = true;
			else if (token.equals("BOREN10"))
				boren10 = true;
			else if (token.equals("PWRTEN"))
				pwrten = true;
			else if (token.equals("WINEN"))
				winen = true;
			else if (token.equals("WDTPS30"))
				wdtps30 = true;
			else if (token.equals("WDTPS20"))
				wdtps20 = true;
			else if (token.equals("WDTEN"))
				wdten = true;
			else if (token.equals("WAIT"))
				wait = true;
			else if (token.equals("ABW"))
				abw = true;
			else if (token.equals("BW"))
				bw = true;
			else if (token.equals("GPTREN"))
				gptren = true;
			else if (token.equals("!T1OSCMX"))
				nott1oscmx = true;
			else if (token.equals("HPOL"))
				hpol = true;
			else if (token.equals("LPOL"))
				lpol = true;
			else if (token.equals("PWMPIN"))
				pwmpin = true;
			else if (token.equals("PM"))
				pm = true;
			else if (token.equals("MCLRE"))
				mclre = true;
			else if (token.equals("EXCLKMX"))
				exclkmx = true;
			else if (token.equals("PWM4MX"))
				pwm4mx = true;
			else if (token.equals("SSPMX"))
				sspmx = true;
			else if (token.equals("LPT1OSC"))
				lpt1osc = true;
			else if (token.equals("T1OSCMX"))
				t1oscmx = true;
			else if (token.equals("PBADEN"))
				pbaden = true;
			else if (token.equals("ECCPMX"))
				eccpmx = true;
			else if (token.equals("FLTAMX"))
				fltamx = true;
			else if (token.equals("CCP2MX"))
				ccp2mx = true;
			else if (token.equals("DEBUG"))
				debug = true;
			else if (token.equals("XINST"))
				xinst = true;
			else if (token.equals("BBSIZ"))
				bbsiz = true;
			else if (token.equals("ICPRT"))
				icprt = true;
			else if (token.equals("LVP"))
				lvp = true;
			else if (token.equals("STVREN"))
				stvren = true;
			else if (token.equals("CP7"))
				cp7 = true;
			else if (token.equals("CP6"))
				cp6 = true;
			else if (token.equals("CP5"))
				cp5 = true;
			else if (token.equals("CP4"))
				cp4 = true;
			else if (token.equals("CP3"))
				cp3 = true;
			else if (token.equals("CP2"))
				cp2 = true;
			else if (token.equals("CP1"))
				cp1 = true;
			else if (token.equals("CP0"))
				cp0 = true;
			else if (token.equals("CP"))
				cp = true;
			else if (token.equals("CPD"))
				cpd = true;
			else if (token.equals("CPB"))
				cpb = true;
			else if (token.equals("WRT7"))
				wrt7 = true;
			else if (token.equals("WRT6"))
				wrt6 = true;
			else if (token.equals("WRT5"))
				wrt5 = true;
			else if (token.equals("WRT4"))
				wrt4 = true;
			else if (token.equals("WRT3"))
				wrt3 = true;
			else if (token.equals("WRT2"))
				wrt2 = true;
			else if (token.equals("WRT1"))
				wrt1 = true;
			else if (token.equals("WRT0"))
				wrt0 = true;
			else if (token.equals("WRTD"))
				wrtd = true;
			else if (token.equals("WRTB"))
				wrtb = true;
			else if (token.equals("WRTC"))
				wrtc = true;
			else if (token.equals("EBTR7"))
				ebtr7 = true;
			else if (token.equals("EBTR6"))
				ebtr6 = true;
			else if (token.equals("EBTR5"))
				ebtr5 = true;
			else if (token.equals("EBTR4"))
				ebtr4 = true;
			else if (token.equals("EBTR3"))
				ebtr3 = true;
			else if (token.equals("EBTR2"))
				ebtr2 = true;
			else if (token.equals("EBTR1"))
				ebtr1 = true;
			else if (token.equals("EBTR0"))
				ebtr0 = true;
			else if (token.equals("EBTR"))
				ebtr = true;
			else if (token.equals("EBTRB"))
				ebtrb = true;
			else
				System.err.println("Invalid Config Bit " + token);
		}
	} // ConfigurationBits
	
	public boolean isUsbpll() {
		return usbpll;
	} // isUsbpll
	
	public boolean isCpudiv() {
		return cpudiv;
	} // isCpudiv
	
	public boolean isPlldiv() {
		return plldiv;
	} // isPlldiv
	
	public boolean isIeso() {
		return ieso;
	} // isIeso
	
	public boolean isFscm() {
		return fscm;
	} // isFscm
	
	public boolean isOscsen() {
		return oscsen;
	} // isOscsen
	
	public boolean isFosc20() {
		return fosc20;
	} // isFosc20
	
	public boolean isFosc30() {
		return fosc30;
	} // isFosc30
	
	public boolean isVregen() {
		return vregen;
	} // isVregen
	
	public boolean isBorv() {
		return borv;
	} // isBorv
	
	public boolean isBoren() {
		return boren;
	} // isBoren
	
	public boolean isBoren10() {
		return boren10;
	} // isBoren
	
	public boolean isPwrten() {
		return pwrten;
	} // isPwrten
	
	public boolean isWinen() {
		return winen;
	} // isWinen
	
	public boolean isWdtps30() {
		return wdtps30;
	} // isWdtsp30
	
	public boolean isWdtps20() {
		return wdtps20;
	} //isWdtsp20
	
	public boolean isWdten() {
		return wdten;
	} // isWdten
	
	public boolean isWait() {
		return wait;
	} // isWait
	
	public boolean isBw() {
		return bw;
	} // isBw

	public boolean isAbw() {
		return abw;
	} // isAbw

	public boolean isGptren() {
		return gptren;
	} // isGptren
	
	public boolean isNott1oscmx() {
		return nott1oscmx;
	} // isNott1oscmx
	
	public boolean isHpol() {
		return hpol;
	} // isHpol
	
	public boolean isLpol() {
		return lpol;
	} // isLpol
	
	public boolean isPwmpin() {
		return pwmpin;
	} // isPwmpin
	
	public boolean isPm() {
		return pm;
	} // isPm
	
	public boolean isMclre() {
		return mclre;
	} // isMclre
	
	public boolean isExclkmx() {
		return exclkmx;
	} // isExclkmx
	
	public boolean isPwm4mx() {
		return pwm4mx;
	} // isPwm4mx
	
	public boolean isSspmx() {
		return sspmx;
	} // isSspmx
	
	public boolean isFltamx() {
		return fltamx;
	} // isFltamx
	
	public boolean isLpt1osc() {
		return lpt1osc;
	} // isLpt1osc
	
	public boolean isT1oscmx() {
		return t1oscmx;
	} // isT1oscmx
	
	public boolean isPbaden() {
		return pbaden;
	} // isPbaden
	
	public boolean isEccpmx() {
		return eccpmx;
	} // isEccpmx
	
	public boolean isCcp2mx() {
		return ccp2mx;
	} // isCcp2mx
	
	public boolean isDebug() {
		return debug;
	} // isDebug
	
	public boolean isXinst() {
		return xinst;
	} // isXinst
	
	public boolean isBbsiz() {
		return bbsiz;
	} // isBbsiz
	
	public boolean isIcprt() {
		return icprt;
	} // isIcprt
	
	public boolean isLvp() {
		return lvp;
	} // isLvp
	
	public boolean isStvren() {
		return stvren;
	} // isStvren
	
	public boolean isCp7() {
		return cp7;
	} // isCp7
	
	public boolean isCp6() {
		return cp6;
	} // isCp6
	
	public boolean isCp5() {
		return cp5;
	} // isCp5
	
	public boolean isCp4() {
		return cp4;
	} // isCp4
	
	public boolean isCp3() {
		return cp3;
	} // isCp3
	
	public boolean isCp2() {
		return cp2;
	} // isCp2
	
	public boolean isCp1() {
		return cp1;
	} // isCp1
	
	public boolean isCp0() {
		return cp0;
	} // isCp0
	
	public boolean isCp() {
		return cp;
	} // isCp
	
	public boolean isCpd() {
		return cpd;
	} // isCpd
	
	public boolean isCpb() {
		return cpb;
	} // isCpb
	
	public boolean isWrt7() {
		return wrt7;
	} // isWrt7
	
	public boolean isWrt6() {
		return wrt6;
	} // isWrt6
	
	public boolean isWrt5() {
		return wrt5;
	} // isWrt5
	
	public boolean isWrt4() {
		return wrt4;
	} // isWrt4
	
	public boolean isWrt3() {
		return wrt3;
	} // isWrt3
	
	public boolean isWrt2() {
		return wrt2;
	} // isWrt2
	
	public boolean isWrt1() {
		return wrt1;
	} // isWrt1
	
	public boolean isWrt0() {
		return wrt0;
	} // isWrt0
	
	public boolean isWrtd() {
		return wrtd;
	} // isWrtd
	
	public boolean isWrtb() {
		return wrtb;
	} // isWrtb
	
	public boolean isWrtc() {
		return wrtc;
	} // isWrtc
	
	public boolean isEbtr7() {
		return ebtr7;
	} // isEbtr7
	
	public boolean isEbtr6() {
		return ebtr6;
	} // isEbtr6
	
	public boolean isEbtr5() {
		return ebtr5;
	} // isEbtr5
	
	public boolean isEbtr4() {
		return ebtr4;
	} // isEbtr4
	
	public boolean isEbtr3() {
		return ebtr3;
	} // isEbtr3
	
	public boolean isEbtr2() {
		return ebtr2;
	} // isEbtr2
	
	public boolean isEbtr1() {
		return ebtr1;
	} // isEbtr1
	
	public boolean isEbtr0() {
		return ebtr0;
	} // isEbtr0
	
	public boolean isEbtr() {
		return ebtr;
	} // isEbtr
	
	public boolean isEbtrb() {
		return ebtrb;
	} // isEbtrb
	
	public String toString() {
		String config = new String();
		
		if (usbpll)
			config = config.concat("USBPLL") + ",";

		if (cpudiv)
			config = config.concat("CPUDIV") + ",";

		if (plldiv)
			config = config.concat("PLLDIV") + ",";

		if (ieso)
			config = config.concat("IESO") + ",";

		if (fscm)
			config = config.concat("FSCM") + ",";

		if (oscsen)
			config = config.concat("OSCSEN") + ",";
		
		if (fosc20)
			config = config.concat("FOSC20") + ",";

		if (fosc30)
			config = config.concat("FOSC30") + ",";

		if (vregen)
			config = config.concat("VREGEN") + ",";
		
		if (borv)
			config = config.concat("BORV") + ",";
		
		if (boren)
			config = config.concat("BOREN") + ",";

		if (boren10)
			config = config.concat("BOREN10") + ",";

		if (pwrten)
			config = config.concat("PWRTEN") + ",";

		if (winen)
			config = config.concat("WINEN") + ",";

		if (wdtps30)
			config = config.concat("WDTPS30") + ",";

		if (wdtps20)
			config = config.concat("WDTPS20") + ",";

		if (wdten)
			config = config.concat("WDTEN") + ",";

		if (wait)
			config = config.concat("WAIT") + ",";

		if (bw)
			config = config.concat("BW") + ",";

		if (abw)
			config = config.concat("ABW") + ",";

		if (gptren)
			config = config.concat("GPTREN") + ",";

		if (nott1oscmx)
			config = config.concat("!T1OSCMX") + ",";

		if (hpol)
			config = config.concat("HPOL") + ",";

		if (lpol)
			config = config.concat("LPOL") + ",";

		if (pwmpin)
			config = config.concat("PWMPIN") + ",";

		if (pm)
			config = config.concat("PM") + ",";

		if (mclre)
			config = config.concat("MCLRE") + ",";

		if (exclkmx)
			config = config.concat("EXCLKMX") + ",";

		if (pwm4mx)
			config = config.concat("PWM4MX") + ",";

		if (sspmx)
			config = config.concat("SSPMX") + ",";

		if (lpt1osc)
			config = config.concat("LPT1OSC") + ",";

		if (t1oscmx)
			config = config.concat("T1OSCMX") + ",";

		if (pbaden)
			config = config.concat("PBADEN") + ",";

		if (eccpmx)
			config = config.concat("ECCPMX") + ",";

		if (fltamx)
			config = config.concat("FLTAMX") + ",";

		if (ccp2mx)
			config = config.concat("CCP2MX") + ",";

		if (debug)
			config = config.concat("DEBUG") + ",";

		if (xinst)
			config = config.concat("XINST") + ",";

		if (bbsiz)
			config = config.concat("BBSIZ") + ",";

		if (icprt)
			config = config.concat("ICPRT") + ",";

		if (lvp)
			config = config.concat("LVP") + ",";

		if (stvren)
			config = config.concat("STVREN") + ",";

		if (cp7)
			config = config.concat("CP7") + ",";

		if (cp6)
			config = config.concat("CP6") + ",";

		if (cp5)
			config = config.concat("CP5") + ",";

		if (cp4)
			config = config.concat("CP4") + ",";

		if (cp3)
			config = config.concat("CP3") + ",";

		if (cp2)
			config = config.concat("CP2") + ",";

		if (cp1)
			config = config.concat("CP1") + ",";

		if (cp0)
			config = config.concat("CP0") + ",";

		if (cp)
			config = config.concat("CP") + ",";

		if (cpd)
			config = config.concat("CPD") + ",";

		if (cpb)
			config = config.concat("CPB") + ",";

		if (wrt7)
			config = config.concat("WRT7") + ",";

		if (wrt6)
			config = config.concat("WRT6") + ",";

		if (wrt5)
			config = config.concat("WRT5") + ",";

		if (wrt4)
			config = config.concat("WRT4") + ",";

		if (wrt3)
			config = config.concat("WRT3") + ",";

		if (wrt2)
			config = config.concat("WRT2") + ",";

		if (wrt1)
			config = config.concat("WRT1") + ",";

		if (wrt0)
			config = config.concat("WRT0") + ",";

		if (wrtd)
			config = config.concat("WRTD") + ",";

		if (wrtb)
			config = config.concat("WRTB") + ",";

		if (wrtc)
			config = config.concat("WRTC") + ",";

		if (ebtr7)
			config = config.concat("EBTR7") + ",";

		if (ebtr6)
			config = config.concat("EBTR6") + ",";

		if (ebtr5)
			config = config.concat("EBTR5") + ",";

		if (ebtr4)
			config = config.concat("EBTR4") + ",";

		if (ebtr3)
			config = config.concat("EBTR3") + ",";

		if (ebtr2)
			config = config.concat("EBTR2") + ",";

		if (ebtr1)
			config = config.concat("EBTR1") + ",";

		if (ebtr0)
			config = config.concat("EBTR0") + ",";

		if (ebtr)
			config = config.concat("EBTR") + ",";

		if (ebtrb)
			config = config.concat("EBTRB") + ",";
		
		if (config.length() == 0)
			return "";
		
		// Remove traling comma and return result.
		return config.substring(0, config.length() - 1);
	} // toString

} // ConfigurationBits
