;NSIS Modern User Interface version 1.63
;Basic Example Script
;Written by Joost Verburg

!define MUI_PRODUCT "Jolt PIC18F Bootloader" ;Define your own software name here
!define MUI_VERSION "1.2" ;Define your own software version here

!include "MUI.nsh"

;--------------------------------
;Configuration

  ;General
  OutFile "JoltSetup.exe"

  ;Folder selection page
  InstallDir "$PROGRAMFILES\${MUI_PRODUCT}"
  
  ;Remember install folder
  InstallDirRegKey HKCU "Software\${MUI_PRODUCT}" ""

  ;$9 is being used to store the Start Menu Folder.
  ;Do not use this variable in your script (or Push/Pop it)!

  ;To change this variable, use MUI_STARTMENUPAGE_VARIABLE.
  ;Have a look at the Readme for info about other options (default folder,
  ;registry).

  ;Remember the Start Menu Folder
  !define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKCU" 
  !define MUI_STARTMENUPAGE_REGISTRY_KEY "Software\${MUI_PRODUCT}" 
  !define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "Start Menu Folder"

  !define TEMP $R0

;--------------------------------
;Jolt PIC18F Bootloader Configuration

  !define MUI_LICENSEPAGE
  !define MUI_COMPONENTSPAGE
  !define MUI_DIRECTORYPAGE
  !define MUI_STARTMENUPAGE
  
  !define MUI_ABORTWARNING
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"
  
;--------------------------------
;Language Strings

  ;Description
  LangString DESC_SecCopyUI ${LANG_ENGLISH} "Copy the necessary Jolt files to the application folder."

;--------------------------------
;Data
  
  LicenseData "C:\My Documents\Martin\src\java\Bootloader\docs\Licence.txt"

;--------------------------------
;Installer Sections

Section "Jolt PIC18F Bootloader" SecCopyUI

  SetOutPath "$INSTDIR"
  File "C:\My Documents\Martin\src\java\Bootloader\Bootloader.jar"
   
  SetOutPath "$INSTDIR"
  File "C:\My Documents\Martin\src\java\Bootloader\support\Bootloader.exe"
    
  SetOutPath "$INSTDIR"
  File "C:\My Documents\Martin\src\java\Bootloader\support\Bootload.hex"
  
  SetOutPath "$INSTDIR"
  File "C:\My Documents\Martin\src\java\Bootloader\support\bootload1x20.HEX"
  
  SetOutPath "$INSTDIR"
  File "C:\My Documents\Martin\src\java\Bootloader\support\bootloadext.HEX"
  
  SetOutPath "$INSTDIR"
  File "C:\My Documents\Martin\src\java\Bootloader\support\blink-led.hex"
    
  ;Store install folder
  WriteRegStr HKCU "Software\${MUI_PRODUCT}" "" $INSTDIR
  
  !insertmacro MUI_STARTMENU_WRITE_BEGIN
    
    ;Create shortcuts
    CreateDirectory "$SMPROGRAMS\${MUI_STARTMENUPAGE_VARIABLE}"
    CreateShortCut "$SMPROGRAMS\${MUI_STARTMENUPAGE_VARIABLE}\Jolt PIC18F Bootloader.lnk" "$INSTDIR\Bootloader.exe"
    CreateShortCut "$SMPROGRAMS\${MUI_STARTMENUPAGE_VARIABLE}\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
  
  !insertmacro MUI_STARTMENU_WRITE_END

  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

SectionEnd

;Display the Finish header
;Insert this macro after the sections if you are not using a finish page
!insertmacro MUI_SECTIONS_FINISHHEADER

;--------------------------------
;Descriptions

!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecCopyUI} $(DESC_SecCopyUI)
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END
 
;--------------------------------
;Uninstaller Section

Section "Uninstall"

  Delete "$INSTDIR\Bootloader.jar"
  Delete "$INSTDIR\Bootloader.exe"
  Delete "$INSTDIR\bootloader.properties"
  Delete "$INSTDIR\PicDevices.properties"
  Delete "$INSTDIR\bootload.hex"
  Delete "$INSTDIR\bootload1x20.HEX"
  Delete "$INSTDIR\bootloadext.HEX"
  Delete "$INSTDIR\blink-led.hex"
  Delete "$INSTDIR\Uninstall.exe"

  ;Remove shortcut
  ReadRegStr ${TEMP} "${MUI_STARTMENUPAGE_REGISTRY_ROOT}" "${MUI_STARTMENUPAGE_REGISTRY_KEY}" "${MUI_STARTMENUPAGE_REGISTRY_VALUENAME}"
  
  StrCmp ${TEMP} "" noshortcuts
  
    Delete "$SMPROGRAMS\${TEMP}\Jolt PIC18F Bootloader.lnk"
    Delete "$SMPROGRAMS\${TEMP}\Uninstall.lnk"
    RMDir "$SMPROGRAMS\${TEMP}" ;Only if empty, so it won't delete other shortcuts
    
  noshortcuts:

  RMDir "$INSTDIR"

  DeleteRegKey /ifempty HKCU "Software\${MUI_PRODUCT}"
  
  ;Display the Finish header
  !insertmacro MUI_UNFINISHHEADER

SectionEnd