/*
 * @(#)ProgressDialog.java	0.1 02/09/27 SMI
 *
 * Copyright (c) 2002 Martin Dubuc All Rights Reserved.
 *
 * Martin Dubuc grants you ("Licensee") a non-exclusive, royalty free, 
 * license to use, modify and redistribute this software in source and
 * binary code form, provided that i) this copyright notice and license
 * appear on all copies of the software; and ii) Licensee does not utilize
 * the software in a manner which is disparaging to Martin Dubuc.
 *
 * This software is provided "AS IS," without a warranty of any kind.
 * ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES,
 * INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. MARTIN
 * DUBUC AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THE
 * SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL MARTIN DUBUC OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR
 * DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE
 * DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,
 * ARISING OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF MARTIN
 * DUBUC HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control
 * of aircraft, air traffic, aircraft navigation or aircraft
 * communications; or in the design, construction, operation or
 * maintenance of any nuclear facility. Licensee represents and
 * warrants that it will not use or redistribute the Software for such
 * purposes.
 */

public class Utils {
  static public String hexToAscii(int val) {
    int hiNibble, loNibble;
    StringBuffer buffer = new StringBuffer();

    hiNibble = (val & 0xf0) >> 4;
    loNibble = val & 0xf;

    if (hiNibble <= 9) {
      buffer.append((char)(hiNibble + '0'));
    }
    else {
      buffer.append((char)(hiNibble - 10 + 'A'));
    }
    
    if (loNibble <= 9) {
      buffer.append((char)(loNibble + '0'));
    }
    else {
      buffer.append((char)(loNibble - 10 + 'A'));
    }

    return buffer.toString();
  } // hexToAscii

  static public int asciiToHex(StringBuffer str) {
    char hiNibble = str.charAt(0);
    char loNibble;

    if (str.length() == 0)
      return 0;

    if (hiNibble >= '0' && hiNibble <= '9') {
      hiNibble -= '0';
    }
    else if (hiNibble >= 'a' && hiNibble <= 'f') {
      hiNibble = (char) ((int) hiNibble - 'a' + 10);
    }
    else if (hiNibble >= 'A' && hiNibble <= 'F') {
      hiNibble = (char) ((int) hiNibble - 'A' + 10);
    }
    else {
      hiNibble = 0;
    }
 
    if (str.length() == 2) {
      loNibble = str.charAt(1);

      if (loNibble >= '0' && loNibble <= '9') {
        loNibble -= '0';
      }
      else if (loNibble >= 'a' && loNibble <= 'f') {
        loNibble = (char) ((int) loNibble - 'a' + 10);
      }
      else if (loNibble >= 'A' && loNibble <= 'F') {
        loNibble = (char) ((int) loNibble - 'A' + 10);
      }
      else {
        loNibble = 0;
      }
    }
    else
      loNibble = 0;

    return (hiNibble << 4) | loNibble;
  } // asciiToHex

  static boolean isHexDigit(int a) {
    if ((a >= '0' && a <= '9') ||
        (a >= 'a' && a <= 'f') ||
        (a >= 'A' && a <= 'F'))
      return true;

    return false; 
  } // isHexDigit
} // Utils
